<script lang="ts">
import Vue from 'vue';
import { IsMobileMixin } from '../../mixins';
import dibFutureOfGitLab from './dib-future-of-gitlab.vue';
import dibPillar3 from './dib-pillar-3.vue';
import dibPillar2 from './dib-pillar-2.vue';
import dibPillar1Talent from './dib-pillar-1-talent.vue';
import dibPillar1Stats from './dib-pillar-1-stats.vue';
import dibPillar1Leadership from './dib-pillar-1-leadership.vue';
import dibPillar1Equip from './dib-pillar-1-equip.vue';

export default Vue.extend({
  name: 'DibTabs',
  components: {
    dibFutureOfGitLab,
    dibPillar3,
    dibPillar2,
    dibPillar1Talent,
    dibPillar1Stats,
    dibPillar1Leadership,
    dibPillar1Equip,
  },
  mixins: [IsMobileMixin],
  props: {
    tabsData: {
      type: Array,
      required: true,
      default() {
        return [];
      },
    },
    cta: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      activeSection: '',
    };
  },
  mounted() {
    this.setupIntersectionObserver();
    window.addEventListener('hashchange', this.setActiveSectionFromHash);
    this.setActiveSectionFromHash();
  },
  beforeDestroy() {
    this.disconnectIntersectionObserver();
    window.removeEventListener('hashchange', this.setActiveSectionFromHash);
  },
  methods: {
    setupIntersectionObserver() {
      const observerOptions = {
        root: null,
        rootMargin: '0px 0px -50% 0px', // maintains accuracy with offset of scroll anchor
        threshold: 0.1,
      };

      const observerCallback = (entries) => {
        entries.forEach((entry) => {
          if (entry.isIntersecting) {
            this.activeSection = entry.target.id;
          }
        });
      };

      this.observer = new IntersectionObserver(
        observerCallback,
        observerOptions,
      );

      if (this.$refs.navigationBar) {
        this.observer.observe(this.$refs.navigationBar);
      }

      this.$el
        .querySelectorAll('.navigation__section .anchor')
        .forEach((anchor) => {
          this.observer.observe(anchor);
        });
    },
    disconnectIntersectionObserver() {
      if (this.observer) {
        this.observer.disconnect();
      }
    },
    setActiveSectionFromHash() {
      const hash = this.$route.hash;
      this.activeSection = hash.replace('#', '');
    },
  },
});
</script>

<template>
  <div class="navigation">
    <div id="navigation-bar" ref="navigationBar" class="navigation__wrapper">
      <nav v-if="!isMobile" class="navigation__options">
        <ul class="navigation__tabs" role="tablist" aria-labelledby="tablist-1">
          <li
            v-for="tab in tabsData"
            :key="tab.header"
            :class="{ active: tab.id.toLowerCase() === activeSection }"
            class="navigation__tab-item"
          >
            <a
              :href="`#${tab.id}`"
              class="navigation__tab-link"
              :data-ga-name="tab.description.toLowerCase()"
              data-ga-location="navigation tabs"
            >
              <SlpTypography variant="body2-bold" tag="p">
                {{ tab.header }}
              </SlpTypography>
              <SlpTypography variant="body2" tag="p">
                {{ tab.description }}
              </SlpTypography>
            </a>
          </li>
        </ul>
        <div v-if="cta.href" class="navigation__tabs-cta">
          <SlpButton
            variant="tertiary"
            :href="cta.href"
            :data-ga-name="cta.data_ga_name"
            :data-ga-location="cta.data_ga_location"
            >{{ cta.text }}</SlpButton
          >
        </div>
      </nav>
    </div>
    <div
      v-for="(tabContent, tabContentIndex) in tabsData"
      :key="`tab-content-${tabContentIndex}`"
      class="navigation__section"
    >
      <div :id="tabContent.id" class="anchor" />
      <component
        :is="component.name"
        v-for="(component, index) in tabContent.components"
        :key="component.name + `-${index}`"
        :data="component.data"
      />
    </div>
  </div>
</template>

<style lang="scss" scoped>
.navigation {
  position: relative;

  &__wrapper {
    background-color: $color-surface-800;
    position: sticky;
    top: 80px;
    width: 100%;
    z-index: 50;
  }
  &__tab-item {
    list-style: none;

    &.active,
    &:hover {
      border-bottom: 3px solid $color-text-link-100;
      text-decoration: none;
    }
  }

  &__tab-link {
    color: $color-secondary-300;
    padding: $spacing-24;
    display: block;
    text-decoration: none !important; // overrides global style
  }

  &__options {
    width: 100%;
    display: flex;
    justify-content: space-between;
  }

  &__tabs {
    display: flex;
    flex-direction: column;
    padding-left: 24px;
    background-color: $color-surface-800;

    @media (min-width: $breakpoint-sm) {
      flex-direction: row;
    }
  }

  &__tabs-cta {
    display: flex;
    align-items: center;
    padding-right: 24px;
    background-color: $color-surface-800;

    a {
      color: $color-text-link-100;
      text-decoration: none;

      &:hover {
        text-decoration: none;
      }
    }
  }

  &__section {
    display: block;
    padding-bottom: 56px;
    overflow-x: clip;

    .anchor {
      margin-top: 64px;
      position: relative;
      top: -100px; // scroll offset so nav does not cover heading
      @media (max-width: $breakpoint-md) {
        top: -60px;
      }
    }
  }
}
</style>
